import { ParamSerializationConfig } from './converters/index.js';
export { NumberParam, ObjectParam, StringParam } from './converters/index.js';
import * as vue from 'vue';
import 'vue-router';

declare function useQueryParam<TParam>(name: string, { serialize, deserialize }: ParamSerializationConfig<TParam>): vue.WritableComputedRef<TParam>;

declare function withDefault<TParam>({ serialize, deserialize }: ParamSerializationConfig<TParam>, defaultValue: NonNullable<TParam>): ParamSerializationConfig<TParam>;

export { ParamSerializationConfig, useQueryParam, withDefault };
