var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  NumberParam: () => NumberParam,
  ObjectParam: () => ObjectParam,
  StringParam: () => StringParam,
  useQueryParam: () => useQueryParam,
  withDefault: () => withDefault
});
module.exports = __toCommonJS(src_exports);

// src/converters/NumberParam.ts
var NumberParam = {
  serialize: (value) => Number.isFinite(value) ? `${value}` : null,
  deserialize: (value) => {
    try {
      const parsedValue = Number.parseFloat(value);
      return Number.isFinite(parsedValue) ? parsedValue : null;
    } catch {
      return null;
    }
  }
};

// src/converters/ObjectParam.ts
function ObjectParam() {
  return {
    serialize: (value) => encodeURIComponent(JSON.stringify(value)),
    deserialize: (value) => {
      try {
        return JSON.parse(decodeURIComponent(value));
      } catch {
        return null;
      }
    }
  };
}

// src/converters/StringParam.ts
var StringParam = {
  serialize: (value) => value,
  deserialize: (value) => value
};

// src/core/useQueryParam.ts
var import_vue = require("vue");
var import_vue_router = require("vue-router");
function useQueryParam(name, { serialize, deserialize }) {
  const router = (0, import_vue_router.useRouter)();
  const route = (0, import_vue_router.useRoute)();
  async function setQueryParam(value) {
    const serializedValue = serialize(value);
    const otherKeys = Object.keys(route.query).filter((key) => key !== name);
    const otherQueryParams = Object.fromEntries(
      otherKeys.map((key) => [key, route.query[key]])
    );
    await router.replace({
      query: {
        ...otherQueryParams,
        ...value !== null ? { [name]: serializedValue } : {}
      }
    });
  }
  return (0, import_vue.computed)({
    get: () => deserialize(route.query[name]),
    set: (value) => setQueryParam(value)
  });
}

// src/core/withDefault.ts
function withDefault({ serialize, deserialize }, defaultValue) {
  return {
    serialize,
    deserialize: (value) => deserialize(value) ?? defaultValue
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  NumberParam,
  ObjectParam,
  StringParam,
  useQueryParam,
  withDefault
});
//# sourceMappingURL=index.js.map