import {
  NumberParam,
  ObjectParam,
  StringParam
} from "./chunk-HQIGQMD4.mjs";

// src/core/useQueryParam.ts
import { computed } from "vue";
import { useRoute, useRouter } from "vue-router";
function useQueryParam(name, { serialize, deserialize }) {
  const router = useRouter();
  const route = useRoute();
  async function setQueryParam(value) {
    const serializedValue = serialize(value);
    const otherKeys = Object.keys(route.query).filter((key) => key !== name);
    const otherQueryParams = Object.fromEntries(
      otherKeys.map((key) => [key, route.query[key]])
    );
    await router.replace({
      query: {
        ...otherQueryParams,
        ...value !== null ? { [name]: serializedValue } : {}
      }
    });
  }
  return computed({
    get: () => deserialize(route.query[name]),
    set: (value) => setQueryParam(value)
  });
}

// src/core/withDefault.ts
function withDefault({ serialize, deserialize }, defaultValue) {
  return {
    serialize,
    deserialize: (value) => deserialize(value) ?? defaultValue
  };
}
export {
  NumberParam,
  ObjectParam,
  StringParam,
  useQueryParam,
  withDefault
};
//# sourceMappingURL=index.mjs.map